-- original by vrid
local function Gradient( f, t, orn )
	local f1, f2
	local img = love.image.newImageData( 4, 4 )
	for j = 0, 3 do
		for i = 0, 3 do
			if orn == 1 then
				f1, f2 = ( 6 - i - j ) / 6, ( i + j ) / 6
			elseif orn == 2 then
				f1,f2 = (3 - i) / 3, i / 3
			elseif orn == 3 then
				f1, f2 = ( 3 - i + j ) / 6, ( i + 3 - j ) / 6
			elseif orn == 4 then
				f1,f2 = j / 3, ( 3 - j ) / 3
			elseif orn == 5 then
				f1,f2 = ( i+ j ) / 6, ( 6 - i - j ) / 6
			elseif orn == 6 then
				f1,f2 = i / 3, ( 3 - i ) / 3
			elseif orn == 7 then
				f1,f2 = ( 3 + i - j ) / 6, ( 3 - i + j ) / 6
			else
				f1,f2 = ( 3 - j ) / 3, j / 3
				end
			img:setPixel( j, i, (f1*t[1]+f2*f[1]), (f1*t[2]+f2*f[2]), (f1*t[3]+f2*f[3]), 255 )
			end
		end
	img = love.graphics.newImage( img )
	img:setFilter('linear', 'linear')
	return {		-- returns table with 'draw' as index to a function
		draw = function( x,y, w,h, r, ox,oy, kx,ky )
			ox = (ox or 0) / w
			oy = (oy or 0) / h
			love.graphics.draw( img, x,y, r or 0, w/4, h/4, ox,oy, kx,ky )
			end
		}
	end

function love.load()
	tt = 1
	op = {'inverted descending','horizontal','ascending','inverted verticle','descending','inverted ascending','verticle'}
	orientation = 1
	love.graphics.setCaption( "Modification of vrid's much nicer script" )
	end

function love.update(dt)
	tt = tt + dt
	if tt >=.5 then
		tt = 0
		orientation = orientation < #op and orientation + 1 or 1
		gradient  = Gradient( {  40, 85,175}, {140,218,234}, orientation )
		gradient2 = Gradient( { 255,  0,  0}, {  0,255,  0}, orientation )
		end
	end

function love.draw()
	gradient.draw( 10, 10, love.graphics.getWidth() - 20, 200 )
	gradient2.draw( 10, 220, 250, 250 )
	love.graphics.print( op[orientation], 10, 550 )
	love.graphics.print( 'fps: '..love.timer.getFPS(), 10, 580 )
	end

function love.keypressed(key)
	if key == 'escape'	then love.event.push( 'quit' ) end
	end
